define bi_coreutils::chmod (
  $path = $title,
  $recursive = false,
  $mode = undef,
  $refreshonly = false,
) {
    require bi_coreutils::stat::params
    require bi_coreutils::chmod::params
    
    if !$path { fail("path must be defined") }
    if !$mode { fail("mode must be defined") }
  
    if $recursive {
        $arg_recursive = $recursive ? {
            true => "-R",
            default => undef,
        }
    }
  
    $args = join(delete_undef_values([ 
        $arg_recursive,
    ]), " ")
    
    exec { "$bi_coreutils::chmod::params::exe_path $args $mode $path":
        unless => "/bin/sh -c '[ \$($bi_coreutils::stat::params::exe_path -c %a $path) == $mode ]'",
        refreshonly => $refreshonly,
    }  

    # unless is using the File check pattern described here
    # http://projects.puppetlabs.com/projects/1/wiki/File_Permission_Check_Patterns
}