define bi_coreutils::sleep (
    $number = undef,
    $suffix = 's',
) {
    require bi_coreutils::sleep::params
    
    if $number != undef and !is_numeric($number) { 
        fail("'number' must be defined and a number") 
    }
    
    if $suffix != undef { 
        if is_string($suffix) {
            validate_re($suffix, ['s', 'm', 'h', 'd'])
        } else {
            fail("'suffix' must be defined and one of the following: 's', 'm', 'h', 'd'")
        } 
    }
    
    exec { "$bi_coreutils::sleep::params::exe_path ${number}${suffix}": }
}